#include <stdio.h>
#include <graphics.h>
#include <math.h>
#include <conio.h>
#include <alloc.h>
#include <stdlib.h>

#include "mys.h"
#include "mat_fce.h"
#include "win_fce.h"
#include "beh_prog.h"


const float PI=3.1415926536;


char *texty[]={"Zadejte nazev souboru: ",
	       "Zadejte ",
	       ". primku:",
	       "Bod A (x, y, z): ",
	       "Bod B (x, y, z): ",
	       "Souradnice bodu krychle",
	       "[ x, y, z ]",
	       "primka 1 A: ",
	       "primka 1 B: ",
	       "primka 2 A: ",
	       "primka 2 B: ",
	       "Souradnice bodu primek",
	       "KRYCHLE        (c) Martin Kot"};


void kresli_krychli(krychle vstup,int sx, int sy, int zobr)
{
  krychle2d krych2d;
  if(zobr==KOS)
    krych2d=kosouhle_krychle(vstup);
  if(zobr==AXON)
    axonom(&vstup.K, &krych2d.K, BODU_KRYCHLE, AX_ALFA, AX_BETA);

  setcolor(BARVA_KRYCHLE);
  moveto(sx+krych2d.K.x,sy-krych2d.K.y);
  lineto(sx+krych2d.L.x,sy-krych2d.L.y);
  lineto(sx+krych2d.M.x,sy-krych2d.M.y);
  lineto(sx+krych2d.N.x,sy-krych2d.N.y);
  lineto(sx+krych2d.K.x,sy-krych2d.K.y);
  lineto(sx+krych2d.O.x,sy-krych2d.O.y);
  lineto(sx+krych2d.P.x,sy-krych2d.P.y);
  lineto(sx+krych2d.Q.x,sy-krych2d.Q.y);
  lineto(sx+krych2d.R.x,sy-krych2d.R.y);
  lineto(sx+krych2d.O.x,sy-krych2d.O.y);
  moveto(sx+krych2d.L.x,sy-krych2d.L.y);
  lineto(sx+krych2d.P.x,sy-krych2d.P.y);
  moveto(sx+krych2d.M.x,sy-krych2d.M.y);
  lineto(sx+krych2d.Q.x,sy-krych2d.Q.y);
  moveto(sx+krych2d.N.x,sy-krych2d.N.y);
  lineto(sx+krych2d.R.x,sy-krych2d.R.y);
  setcolor(BARVA_BODU1);
  line(sx+krych2d.K.x-DK,sy-krych2d.K.y+DK,sx+krych2d.K.x+DK,sy-krych2d.K.y-DK);
  line(sx+krych2d.K.x-DK,sy-krych2d.K.y-DK,sx+krych2d.K.x+DK,sy-krych2d.K.y+DK);
  setcolor(BARVA_BODU2);
  line(sx+krych2d.L.x-DK,sy-krych2d.L.y+DK,sx+krych2d.L.x+DK,sy-krych2d.L.y-DK);
  line(sx+krych2d.L.x-DK,sy-krych2d.L.y-DK,sx+krych2d.L.x+DK,sy-krych2d.L.y+DK);
  line(sx+krych2d.R.x-DK,sy-krych2d.R.y+DK,sx+krych2d.R.x+DK,sy-krych2d.R.y-DK);
  line(sx+krych2d.R.x-DK,sy-krych2d.R.y-DK,sx+krych2d.R.x+DK,sy-krych2d.R.y+DK);
}



void kresli_primky(primka p1, krychle krych, int sx, int sy, float meritko, float teluhl, int zobr)
{
  int i;
  bod2d b2d[4];
  bod3d bod[4];
  bod3d S3;
  bod2d S2;
  krychle2d krych2d;

  bod[0]=urci_bod(krych.R,krych.R-krych.L,teluhl);
  bod[1]=urci_bod(krych.L,krych.L-krych.R,teluhl);
  bod[2]=urci_bod(krych.K,p1.u,teluhl*2);
  bod[3]=urci_bod(krych.K,-p1.u,teluhl*2);
  zvetseni(bod,bod,4,meritko);
  if(zobr==KOS)
    for(i=0;i<4;i++)
      b2d[i]=kosouhle(bod[i]);
  if(zobr==AXON)
      axonom( bod, b2d, 4, AX_ALFA, AX_BETA);
  setcolor(BARVA_PRIMKY);
  line(sx+b2d[0].x,sy-b2d[0].y,sx+b2d[1].x,sy-b2d[1].y);
  line(sx+b2d[2].x,sy-b2d[2].y,sx+b2d[3].x,sy-b2d[3].y);
}

void kresli(krychle vstup, primka p, win *roz_ok, int zobr)
{
  krychle2d krych2d, *uk;
  krychle krych3d;
  bod3d S3;
  bod2d S2;
  int sx,sy;
  double teluhl;
  double meritko;
  viewporttype viewinfo;

  getviewsettings(&viewinfo);
  setviewport(roz_ok->left+1,roz_ok->top+1,roz_ok->right-1,roz_ok->bottom-1,1);
  int SX=(roz_ok->right - roz_ok->left)/2;
  int SY=(roz_ok->bottom - roz_ok->top)/2;

  smaz_okno(roz_ok,GR_WIN);
  dis();
  teluhl=vzdal_bodu(vstup.K,vstup.Q);
  meritko=(roz_ok->y*POMER)/teluhl;
  S3=urci_bod(vstup.K,vstup.Q-vstup.K,teluhl/2);
  zvetseni(&S3,&S3,1,meritko);
  if(zobr==KOS)
    S2=kosouhle(S3);
  if(zobr==AXON)
    axonom(&S3, &S2, 1, AX_ALFA, AX_BETA);
  sx=SX-zaokrouhli(S2.x);
  sy=roz_ok->y - SY+zaokrouhli(S2.y);
  zvetseni(&vstup.K,&krych3d.K,BODU_KRYCHLE,meritko);
  kresli_primky(p,vstup,sx,sy,meritko,teluhl,zobr);
  kresli_krychli(krych3d,sx,sy,zobr);
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  en();
}


int zadavani(int x, int y, char *ret)
{
  int i=0;
  char znak='\0';
  int akt_x, akt_y, akt_col, delka, mx, my;

  akt_col=getcolor();
  moveto(x,y);
  stisk(PRAVE,&mx,&my);
  while(znak != '\r')
  {
    while(!kbhit())
      if(stisk(PRAVE,&mx,&my)==TRUE)
	return FALSE;
    znak=getch();

    if(znak=='\0')
    {
      getch();
      continue;
    }
    if(znak == '\r')
    {
      ret[i]='\0';
      break;
    }
    if(znak == '\b')
    {
      if(i>0)
      {
	ret[i]='\0';
	delka=textwidth(ret+i-1);
	moverel(-delka,0);
	setcolor(BROWN);
	dis();
	outtext(ret+i-1);
	en();
	moverel(-delka,0);
	setcolor(akt_col);
	i--;
      }
    }
    else
    {
      if(i>24)
	continue;
      dis();
      outtext(&znak);
      en();
      ret[i]=znak;
      i++;
    }
  }
  ret[i]='\0';
  return TRUE;
}

int nacti_primku(primka *p1, primka *p2, win *roz_ok)
{
  char p_ret[RETEZEC], zprava1[RETEZEC], zprava2[RETEZEC];
  int i, j, k,TEXT_X,TEXT_Y;
  viewporttype viewinfo;
  bod3d b;
  int max_y=getmaxy();
  int vel_textu=(max_y+1)/STREDNI;
  TEXT_X=(roz_ok+T_WIN)->chx;
  TEXT_Y=((roz_ok+T_WIN)->bottom-(roz_ok+T_WIN)->top)/2;

  getviewsettings(&viewinfo);
  k=1;
  j=1;
  setviewport((roz_ok+T_WIN)->left,(roz_ok+T_WIN)->top,(roz_ok+T_WIN)->right,(roz_ok+T_WIN)->bottom,1);
  settextstyle(SMALL_FONT,HORIZ_DIR,vel_textu);
  vel_textu*=3;
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  setfillstyle(SOLID_FILL,BROWN);
  sprintf(zprava1,"%s%d%s",texty[ZADEJ],k,texty[PRIM]);
  sprintf(zprava2,texty[BOD_A]);
  while(TRUE)
  {
    setcolor(ZAD_COL);
    dis();
    outtextxy(TEXT_X,TEXT_Y,zprava1);
    outtextxy(TEXT_X,TEXT_Y+vel_textu,zprava2);

    en();
    if(zadavani((roz_ok+T_WIN)->chx+textwidth(zprava2),TEXT_Y+vel_textu,p_ret)==FALSE)
    {
      smaz_okno(roz_ok,T_WIN);
      setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
      return FALSE;
    }
    for(i=0;i<RETEZEC;i++)
    {
      if((p_ret[i]<'0'||p_ret[i]>'9') && p_ret[i] != '.' && p_ret[i] !='e'
	 && p_ret[i] !='E' && p_ret[i] !='\0' && p_ret[i] !='-')
	p_ret[i]=' ';
    }
    if(sscanf(p_ret,"%f%f%f",&b.x,&b.y,&b.z)!=3)
    {
      pis_chybu(roz_ok,SPATNE_SOURADNICE);
      setcolor(ZAD_COL);
      continue;
    }
    else
    {
      smaz_okno(roz_ok,T_WIN);
      if(k==1)
	if(j==1)
	{
	  j++;
	  sprintf(zprava2,texty[BOD_B]);
	  p1->A=b;
	}
	else
	{
	  if( (p1->A.x==b.x) && (p1->A.y==b.y) && (p1->A.z==b.z) )
	    pis_chybu(roz_ok,STEJNE_BODY);
	  else
	  {
	    k++;
	    j--;
	    sprintf(zprava1,"%s%d%s",texty[ZADEJ],k,texty[PRIM]);
	    sprintf(zprava2,texty[BOD_B]);
	    p1->u=b - (p1->A);
	  }
	}
      else
	if(j==1)
	{
	  j++;
	  sprintf(zprava2,texty[BOD_B]);
	  p2->A=b;
	}
	else
	{
	  if( (p2->A.x==b.x) && (p2->A.y==b.y) && (p2->A.z==b.z) )
	    pis_chybu(roz_ok,STEJNE_BODY);
	  else
	  {
	    p2->u=b - (p2->A);
	    if(kontrola_primek(*p1,*p2,roz_ok)==MIMOBEZNE)
	      break;
	    else
	    {
	      j=1;
	      k=1;
	      sprintf(zprava1,"%s%d%s",texty[ZADEJ],k,texty[PRIM]);
	      sprintf(zprava2,texty[BOD_A]);
	    }
	  }
	}
    }
  }
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  return TRUE;
}


FILE *zadani_souboru(win *roz_ok)
{
  int TEXT_X,TEXT_Y,delka;
  char jmeno[RETEZEC];
  viewporttype viewinfo;
  FILE *soubor;
  int max_y=getmaxy();
  int vel_textu=(max_y+1)/STREDNI;

  getviewsettings(&viewinfo);
  setviewport((roz_ok+T_WIN)->left,(roz_ok+T_WIN)->top,(roz_ok+T_WIN)->right,(roz_ok+T_WIN)->bottom,1);
  settextstyle(SMALL_FONT,HORIZ_DIR,vel_textu);
  settextjustify(LEFT_TEXT,TOP_TEXT);
  setfillstyle(SOLID_FILL,BROWN);
  setcolor(YELLOW);
  TEXT_X=(roz_ok+T_WIN)->chx;
  TEXT_Y=((roz_ok+T_WIN)->bottom-(roz_ok+T_WIN)->top)/2;
  outtextxy(TEXT_X,TEXT_Y+3*vel_textu,texty[NAZ_SOUB]);
  delka=textwidth(texty[NAZ_SOUB]);
  if(zadavani(TEXT_X+delka,TEXT_Y+3*vel_textu,jmeno)==FALSE)
  {
    clearviewport();
    setcolor(WHITE);
    bar3d(0,0,(roz_ok+T_WIN)->x,(roz_ok+T_WIN)->y,0,1);
    setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
    return NULL;
  }
  if((soubor=fopen(jmeno,"r"))==NULL)
  {
/*    clearviewport();
    setcolor(WHITE);
    bar3d(0,0,(roz_ok+T_WIN)->x,(roz_ok+T_WIN)->y,0,1);
    setcolor(RED);
    outtextxy((roz_ok+T_WIN)->chx,(roz_ok+T_WIN)->chy,chyby[NELZE_OT]);*/
    pis_chybu(roz_ok,NELZE_OT);
  }
  else
    fseek(soubor,0L,SEEK_SET);
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  return soubor;
}



int nacti_primku(primka *p1, primka *p2,win *roz_ok,FILE *data)
{
  char p_ret[RETEZEC];
  int j,i,k,znak;
  bod3d point[4];
  viewporttype viewinfo;

  for(j=0;j<4;)
  {
    i=0;

    while(!feof(data))
    {
      znak=getc(data);
      if(znak=='\n'||znak==EOF)
      {
	p_ret[i]='\0';
	k=sscanf(p_ret,"%f%f%f",&point[j].x,&point[j].y,&point[j].z);
	if(k==0||k==EOF)
	{
	  i=0;
	  continue;
	}
	if(k!=3 )
	{
	  pis_chybu(roz_ok,FORMAT_SOUB);
	  return SPATNY_FORMAT;
	}
	else
	  break;
      }
      if((znak<'0'||znak>'9') && znak != '.' && znak !='e'
		 && znak !='E' && znak !='\0' && znak !='-')
	p_ret[i]=' ';
      else
	p_ret[i]=znak;
      i++;
    }
    if(feof(data))
    {
      pis_chybu(roz_ok,MALO_SOURAD);
      return MALO_BODU;
    }
    j++;
  }
  p1->A=point[0];
  p1->u=point[1]-point[0];
  p2->A=point[2];
  p2->u=point[3]-point[2];
  if((p1->u.x==0 && p1->u.y==0 && p1->u.z==0) || (p2->u.x==0 && p2->u.y==0 && p2->u.z==0))
  {
    pis_chybu(roz_ok,SOUB_STEJNE_BODY);
    return STEJNE_BODY;
  }
  return 0;
}


int novy_soubor(FILE **soub,win *roz_ok,button *tlac, krychle *kr,primka *pr1,primka *pr2)
{
  int tl[POCET_TLAC],puvodni[POCET_TLAC];
  int mx,my,kontr;
  primka p1,p2;

  for(int i=0;i<POCET_TLAC;i++)
  {
    tl[i]=TRUE;
    puvodni[i]=(tlac+i)->stav;
  }
  tl[BACK]=FALSE;
  nastav_tlac(tlac);
  smaz_okno(roz_ok,T_WIN);
  if(*soub!=NULL)
    fclose(*soub);
  if((*soub=zadani_souboru(roz_ok))==NULL)
  {
    nastav_tlac(tlac,puvodni);
    return FALSE;
  }
  kontr=nacti_primku(&p1,&p2,roz_ok,*soub);
  if(kontr==MALO_BODU)
  {
    stav_tlac(tlac,POKR_SOUB,FALSE);
    return FALSE;
  }
  if(kontr==SPATNY_FORMAT || kontr==SHODNE_BODY)
    return FALSE;

  if(kontrola_primek(p1,p2,roz_ok)!=MIMOBEZNE)
  {
    nastav_tlac(tlac,puvodni);
    return FALSE;
  }
  *pr1=p1;
  *pr2=p2;
  najdi_krychle(p1,p2,kr,kr+1,kr+2,kr+3);
  kresli(*kr,p2,roz_ok,1);
  nastav_tlac(tlac,tl);
  return TRUE;
}


int pokracovani_souboru(FILE *soub, win *roz_ok, button *tlac,krychle *kr,primka *pr1, primka *pr2)
{
  int tl[POCET_TLAC];
  int kontr;
  primka p1,p2;

  for(int i=0;i<POCET_TLAC;i++)
    tl[i]=TRUE;
  tl[BACK]=FALSE;

  if(soub==NULL)
  {
    stav_tlac(tlac,POKR_SOUB,FALSE);
    return FALSE;
  }
  smaz_okno(roz_ok,T_WIN);
  kontr=nacti_primku(&p1,&p2,roz_ok,soub);
  if(kontr==MALO_BODU || kontr==SHODNE_BODY)
  {
    stav_tlac(tlac,POKR_SOUB,FALSE);
    return FALSE;
  }
  if(kontr==SPATNY_FORMAT)
    return FALSE;
  if(kontrola_primek(p1,p2,roz_ok)!=MIMOBEZNE)
  {
    return FALSE;
  }
  *pr1=p1;
  *pr2=p2;
  najdi_krychle(p1,p2,kr,kr+1,kr+2,kr+3);
  kresli(*kr,p2,roz_ok,1);
  nastav_tlac(tlac,tl);
  return TRUE;
}


int klavesnice(win *roz_ok, button *tlac, krychle *kr, primka *pr1, primka *pr2)
{
  int tl[POCET_TLAC], puvodni[POCET_TLAC];
  primka p1,p2;

  for(int i=0;i<POCET_TLAC;i++)
  {
    tl[i]=TRUE;
    puvodni[i]=(tlac+i)->stav;
  }
  tl[POKR_SOUB]=tl[BACK]=FALSE;
  nastav_tlac(tlac);
  smaz_okno(roz_ok,T_WIN);

  if(nacti_primku(&p1,&p2,roz_ok)==FALSE)
  {
    nastav_tlac(tlac,puvodni);
    return FALSE;
  }
  *pr1=p1;
  *pr2=p2;
  najdi_krychle(p1,p2,kr,kr+1,kr+2,kr+3);
  kresli(*kr,p2,roz_ok,1);
  nastav_tlac(tlac,tl);
  return TRUE;
}



int dalsi_reseni(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2, int akt, int zobr)
{
  if(zobr==KOS||zobr==AXON)
  {
    smaz_okno(roz_ok,T_WIN);
    switch(akt){
      case 0:
	kresli(*(kr+1),p2,roz_ok,zobr);
	stav_tlac(tlac,BACK,TRUE);
	break;
      case 1:
	kresli(*(kr+2),p1,roz_ok,zobr);
	break;
      case 2:
	kresli(*(kr+3),p1,roz_ok,zobr);
	stav_tlac(tlac,NEXT,FALSE);
	break;
      default:
	return FALSE;
    }
  }
  else
    souradnice_bodu(roz_ok, tlac, kr, p1, p2, akt+1, zobr);
  return TRUE;
}


int predchozi_reseni(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2,int akt,int zobr)
{
  if(zobr==KOS||zobr==AXON)
  {
    smaz_okno(roz_ok,T_WIN);
    switch(akt){
      case 1:
	stav_tlac(tlac,BACK,FALSE);
	kresli(*(kr),p2,roz_ok,zobr);
	break;
      case 2:
	kresli(*(kr+1),p2,roz_ok,zobr);
	break;
      case 3:
	kresli(*(kr+2),p1,roz_ok,zobr);
	stav_tlac(tlac,NEXT,TRUE);
	break;
      default:
	return FALSE;
    }
  }
  else
    souradnice_bodu(roz_ok,tlac, kr, p1, p2, akt-1, zobr);
  return TRUE;
}


int souradnice_bodu(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2,int akt, int zobr)
{
  int umisti_x,umisti_y;
  char body_kr[BODU_KRYCHLE+4][RETEZEC];
  bod3d *uk;
  int i=0;
  int max_y=getmaxy();
  int VYSKA_RADKU;
  uk=(bod3d *)(kr+akt);
  viewporttype viewinfo;

  smaz_okno(roz_ok,T_WIN);
  if(zobr==TEXT)
  {
    switch(akt) {
      case 0: stav_tlac(tlac,BACK,FALSE);
	break;
      case 1: stav_tlac(tlac,BACK,TRUE);
	break;
      case 2: stav_tlac(tlac,NEXT,TRUE);
	break;
      case 3: stav_tlac(tlac,NEXT,FALSE);
	break;
    }
    smaz_okno(roz_ok,GR_WIN);
    getviewsettings(&viewinfo);
    setviewport(roz_ok->left,roz_ok->top,roz_ok->right,roz_ok->bottom,1);
    umisti_x=roz_ok->x/2;
    umisti_y=roz_ok->y/10;
    settextjustify(CENTER_TEXT,CENTER_TEXT);
    settextstyle(SMALL_FONT,HORIZ_DIR,(max_y+1)/VELKE);
    VYSKA_RADKU=textheight("")*1.3;
    setcolor(NADPIS);
    outtextxy(umisti_x,umisti_y,texty[SOURAD_K]);
    umisti_y+=VYSKA_RADKU;
    outtextxy(umisti_x,umisti_y,texty[XYZ]);
    umisti_y+=VYSKA_RADKU;
    for(int j=0;j<BODU_KRYCHLE;j++)
    {
      sprintf(body_kr[j],"[ %8.3f, %8.3f, %8.3f ]",(uk+j)->x,(uk+j)->y,(uk+j)->z);
    }
    sprintf(body_kr[8],"%s[ %8.3f, %8.3f, %8.3f ]",texty[P1A],p1.A.x,p1.A.y,p1.A.z);
    sprintf(body_kr[9],"%s[ %8.3f, %8.3f, %8.3f ]",texty[P1B],p1.A.x+p1.u.x,p1.A.y+p1.u.y,p1.A.z+p1.u.z);
    sprintf(body_kr[10],"%s[ %8.3f, %8.3f, %8.3f ]",texty[P2A],p2.A.x,p2.A.y,p2.A.z);
    sprintf(body_kr[11],"%s[ %8.3f, %8.3f, %8.3f ]",texty[P2B],p2.A.x+p2.u.x,p2.A.y+p2.u.y,p2.A.z+p2.u.z);

    setcolor(BARVA_BODU1);
    outtextxy(umisti_x,umisti_y,body_kr[i++]);
    setcolor(BARVA_BODU2);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    setcolor(TEXT_COL);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    setcolor(BARVA_BODU2);
    outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);

    setcolor(NADPIS);
    outtextxy(umisti_x,umisti_y+i*VYSKA_RADKU,texty[SOURAD_P]);
    umisti_y+=VYSKA_RADKU;
    if(akt==0 || akt==1)
    {
      setcolor(BARVA_BODU2);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      setcolor(BARVA_BODU1);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    }
    else
    {
      setcolor(BARVA_BODU1);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      setcolor(BARVA_BODU2);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
      outtextxy(umisti_x,umisti_y+(i++)*VYSKA_RADKU,body_kr[i]);
    }
    setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  }
  else
  {
    if(akt!=0)
      dalsi_reseni(roz_ok, tlac, kr, p1, p2, akt-1, zobr);
    else
      predchozi_reseni(roz_ok, tlac, kr, p1, p2, akt+1, zobr);
  }
  return zobr;
}


int napoveda(win *roz_ok,button *tlac)
{
  FILE *hsoub;
  int znak,i,j,k;
  int umisti_x,umisti_y,vyska_radku;
  char nap[NAP_RAD][NAP_SL];
  viewporttype viewinfo;

  stav_tlac(tlac,HELP,FALSE);
  smaz_okno(roz_ok,GR_WIN);
  getviewsettings(&viewinfo);
  setviewport(roz_ok->left,roz_ok->top,roz_ok->right,roz_ok->bottom,1);
  umisti_x=roz_ok->x/40;
  umisti_y=roz_ok->y/40;
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  vyska_radku=textheight("")*1.3;

  if((hsoub=fopen(HELP_SOUB,"r"))==NULL)
  {
    pis_chybu(roz_ok,NENI_HELP,1);
    return -2;
  }
  fseek(hsoub,0L,SEEK_SET);
  i=0;
  j=0;
  while((znak=getc(hsoub))!=EOF)
  {
    if(i==NAP_RAD)
      break;
    if(znak=='\n')
    {
      nap[i][j]='\0';
      i++;
      j=0;
    }
    else
    {
      if(j==NAP_SL-1)
      {
	nap[i][j]='\0';
	i++;
	j=0;
	nap[i][j++]=znak;
      }
      else
	nap[i][j++]=znak;
    }
  }
  nap[i][j]='\0';
  for(k=0;k<i;k++)
  {
    outtextxy(umisti_x,umisti_y+vyska_radku*k,nap[k]);
  }
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  fclose(hsoub);
  return stisk_tlac2(tlac);

}


