#include <stdio.h>

#define DK 3 //delka krizku
#define NAP_RAD 22 //radku napovedy
#define NAP_SL 60 //sloupcu napovedy
#define POMER 0.5
#define RETEZEC 256

#define HELP_SOUB "krychle.hlp"

extern int vel_textu;
typedef enum{
  SPATNY_FORMAT = 1,
  MALO_BODU = 2,
  SHODNE_BODY = 3
  }chyby_souboru;

typedef enum{TEXT,KOS,AXON}zobrazeni;
typedef enum{
  NAZ_SOUB,
  ZADEJ,
  PRIM,
  BOD_A,
  BOD_B,
  SOURAD_K,
  XYZ,
  P1A,
  P1B,
  P2A,
  P2B,
  SOURAD_P,
  NAZEV
  }textove_hl;


void kresli_krychli(krychle vstup,int sx, int sy, int zobr);
void kresli_primky(primka p1, krychle krych, int sx, int sy, float meritko, float teluhl, int zobr);
void kresli(krychle vstup, primka p, win *roz_ok, int zobr);
int zadavani(int x, int y, char *ret);
int nacti_primku(primka *p1, primka *p2, win *roz_ok);
FILE *zadani_souboru(win *roz_ok);
int nacti_primku(primka *p1, primka *p2,win *roz_ok,FILE *data);
int novy_soubor(FILE **soub,win *roz_ok, button *tlac,krychle *kr,primka *pr1,primka *pr2);
int pokracovani_souboru(FILE *soub, win *roz_ok, button *tlac,krychle *kr,primka *pr1, primka *pr2);
int klavesnice(win *roz_ok, button *tlac,krychle *kr, primka *pr1, primka *pr2);
int dalsi_reseni(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2, int akt, int zobr);
int predchozi_reseni(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2,int akt,int zobr);
int souradnice_bodu(win *roz_ok, button *tlac,krychle *kr, primka p1, primka p2,int akt, int zobr);
int napoveda(win *roz_ok,button *tlac);
int kontrola_primek(primka p1, primka p2, win *roz_ok);
