#include <stdio.h>

#define BGI "C:\\bc3\\bgi"
#define POCET_TLAC 8
#define POM_MEZ 48

typedef enum{
  LEVE,
  PRAVE
  }tl_mysi;

typedef enum{
  GR_WIN,
  T_WIN,
  SCH_WIN,
  POCET_OKEN
  } oznac_oken;


typedef enum {
  NOVY_SOUB,
  POKR_SOUB,
  KLAV,
  NEXT,
  BACK,
  SOURAD_BODU,
  HELP,
  KONEC} poradi_tlac;



typedef enum{
      FORMAT_SOUB,
      MALO_SOURAD,
      SHODNE_PR,
      ROVNOBEZNE_PR1,
      ROVNOBEZNE_PR2,
      RUZNOBEZNE_PR1,
      RUZNOBEZNE_PR2,
      SPATNE_SOURADNICE,
      NENI_HELP,
      CHYBA_GRAFIKY,
      NELZE_OT,
      MALO_PAM,
      STEJNE_BODY,
      SOUB_STEJNE_BODY
      }chybove_hl;



typedef enum {
  MALE = 120,
  STREDNI = 96,
  VELKE = 80
  } VEL_PISMA;


typedef enum {
  ENABLE_COL=1,
  NADPIS=4,
  WIN_COL=6,
  BK_COL=7,
  DISABLE_COL=8,
  BARVA_BODU2=10,
  BARVA_KRYCHLE=11,
  BARVA_PRIMKY=12,
  BARVA_BODU1=14,
  ZAD_COL=14,
  PRED_COL=15,
  TEXT_COL=15
  }tlac_colors;

typedef struct
{
  int left;
  int top;
  int right;
  int bottom;
  int x;
  int y;
  int chx;
  int chy;
}win;

typedef struct{
  int stav;
  int left;
  int right;
  int top;
  int bottom;
  int sx;
  int sy;
  } button;



int inic_graf(void);
void kos_schema(win *roz_ok);
void axon_schema(win *roz_ok);
int pis_chybu(win *roz_ok,int cislo,int radku=1);
button *zobraz_tlacitka(int x, int y, int *sirka);
void inicializuj_mys();
int stisk_tlac(button *tlac);
int stisk_tlac2(button *tlac);
int stav_tlac(button *tlac,int tlacitko,int novy_stav);
win *okna(button **tlac);
void smaz_okno(win *roz_ok, int cislo);
void nastav_tlac(button *tlac,int *stavy=NULL);


